; -----------------------------------------------------------
; HtmlCodeAssist.pb 3.0  
; Author: Vern Marsden : vmars316 @ http://www.purebasic.fr/english/
; Author Website: http://www.vmars.us/ 
; Date: Feb 29 , 2020
; OS: Windows x86; Also see pimFind.pb 3.0  
; https://www.purebasic.com/documentation/reference/ug_overview.html 
; https://www.rsbasic.de/tipps-und-tricks/
; TODO 
; Select and press CTRL + B (default binding). CTRL + SHIFT + B to uncomment.
;     https://www.purebasic.fr/english/viewtopic.php?f=18&t=74737
; PostEvent(#PB_Event_CloseWindow) 
;     https://www.purebasic.fr/english/viewtopic.php?f=13&t=74738 
; Dim HtmlHtmlArray(HtmlArrayCount)
; SetClipboardText(GetGadgetText(Editor_1))
; SetGadgetText() 
; ------------------------------------------------------------

Global CurrentPath$ 
Global Editor_1 , Editor_2 , Editor_3 , Editor_4 , Editor_5 , Editor_6 , Editor_7 , Editor_8 , 
       Editor_9 , Editor_10 , Editor_11 , Editor_12 , Editor_13 , Editor_14  
Global Button_1 , Button_2 , Button_3 , Button_4 , Button_5 , Button_6 , Button_7 , Button_8 , 
       Button_9 , Button_10 , Button_11 , Button_12 , Button_13 , Button_14 
Global HelpBtn , LoadDefaults_Btn , SaveDefaults_Btn , ExitBtn , ClearBtn
Global CopyThis = 1 , SaveThis = 0 , HoldEditorStuff$ 
Global NewList HtmlArrayCode.s() , HtmlArrayCount = 0 , CurrentHtmlArrayItem = 0 , CurrentHtmlArrayText$ = ""  

LoadFont(Window_0,"Tahoma", 10)

Enumeration 
  #Window_0 
EndEnumeration 

Declare LoadHtmlArray()

Declare Btn01Paste() 
Declare Btn02Paste() 
Declare Btn03Paste() 
Declare Btn04Paste() 
Declare Btn05Paste() 
Declare Btn06Paste() 
Declare Btn07Paste() 
Declare Btn08Paste() 
Declare Btn09Paste() 
Declare Btn10Paste() 
Declare Btn11Paste() 
Declare Btn12Paste() 
Declare Btn13Paste() 
Declare Btn14Paste() 
Declare ClearAll()
Declare LoadDefaults()

Declare SaveDefaults()

; tooltip

Procedure OpenWindow_0(x = 0, y = 0, width = 810, height = 410)
  Window_0 = OpenWindow(#PB_Any, x, y, width, height, "BUTTONS-HtmlCodeAssist", #PB_Window_SystemMenu)
  CopyTextLabel = TextGadget(#PB_Any, 250, 20, 270, 25, "Copy Text To Clipboard !", #PB_Text_Center)
  
  Editor_1 = StringGadget(#PB_Any, 10, 70, 280, 25, " ")
  GadgetToolTip(Editor_1, "Example: <span style= ' background-color: yellow; ' >")
  Editor_3 = StringGadget(#PB_Any, 10, 110, 280, 25, " ")
  GadgetToolTip(Editor_3, "Example: <span style= ' background-color: yellow; ' >")
  Editor_5 = StringGadget(#PB_Any, 10, 150, 280, 25, " ")
  GadgetToolTip(Editor_5, "Example: <span style= ' background-color: yellow; ' >")
  Editor_7 = StringGadget(#PB_Any, 10, 190, 280, 25, "")
  GadgetToolTip(Editor_7, "Example: <span style= ' background-color: yellow; ' >")
  Editor_9 = StringGadget(#PB_Any, 10, 230, 280, 25, "")
  GadgetToolTip(Editor_9, "Example: <span style= ' background-color: yellow; ' >")
  Editor_11 = StringGadget(#PB_Any, 10, 270, 280, 25, "")
  GadgetToolTip(Editor_11, "Example: <span style= ' background-color: yellow; ' >")
  Editor_13 = StringGadget(#PB_Any, 10, 310, 280, 25, "")
  GadgetToolTip(Editor_13, "Example: <span style= ' background-color: yellow; ' >")
  
  Editor_2 = StringGadget(#PB_Any, 430, 70, 290, 25, "")
  GadgetToolTip(Editor_2, " Example:  </span> or Whatever")
  Editor_4 = StringGadget(#PB_Any, 430, 110, 290, 25, "")
  GadgetToolTip(Editor_4, " Example:  </span> or Whatever")
  Editor_6 = StringGadget(#PB_Any, 430, 150, 290, 25, "")
  GadgetToolTip(Editor_6, " Example:  </span> or Whatever")
  Editor_8 = StringGadget(#PB_Any, 430, 190, 290, 25, "")
  GadgetToolTip(Editor_8, " Example:  </span> or Whatever")
  
  Editor_10 = StringGadget(#PB_Any, 430, 230, 290, 25, "")
  GadgetToolTip(Editor_10, " Example:  </span> or Whatever")
  
  Editor_12 = StringGadget(#PB_Any, 430, 270, 290, 25, "")
  GadgetToolTip(Editor_12, " Example:  </span> or Whatever")
  Editor_14 = StringGadget(#PB_Any, 430, 310, 290, 25, "")
  GadgetToolTip(Editor_14, " Example:  </span> or Whatever")
  
  Button_1 = ButtonGadget(#PB_Any, 310, 70, 60, 25, "Copy")
  GadgetToolTip(Button_1, "Copy Text To Clipboard")
  Button_3 = ButtonGadget(#PB_Any, 310, 110, 60, 25, "Copy")
  GadgetToolTip(Button_3, "Copy Text To Clipboard")
  Button_5 = ButtonGadget(#PB_Any, 310, 150, 60, 25, "Copy")
  GadgetToolTip(Button_5, "Copy Text To Clipboard")
  Button_7 = ButtonGadget(#PB_Any, 310, 190, 60, 25, "Copy")
  GadgetToolTip(Button_7, "Copy Text To Clipboard")
  Button_9 = ButtonGadget(#PB_Any, 310, 230, 60, 25, "Copy")
  GadgetToolTip(Button_9, "Copy Text To Clipboard")
  Button_11 = ButtonGadget(#PB_Any, 310, 270, 60, 25, "Copy")
  GadgetToolTip(Button_11, "Copy Text To Clipboard")
  Button_13 = ButtonGadget(#PB_Any, 310, 310, 60, 25, "Copy")
  GadgetToolTip(Button_13, "Copy Text To Clipboard")
  Button_2 = ButtonGadget(#PB_Any, 730, 70, 60, 25, "Copy")
  GadgetToolTip(Button_2, "Copy Text To Clipboard")
  Button_4 = ButtonGadget(#PB_Any, 730, 110, 60, 25, "Copy")
  GadgetToolTip(Button_4, "Copy Text To Clipboard")
  Button_6 = ButtonGadget(#PB_Any, 730, 150, 60, 25, "Copy")
  GadgetToolTip(Button_6, "Copy Text To Clipboard")
  Button_8 = ButtonGadget(#PB_Any, 730, 190, 60, 25, "Copy")
  GadgetToolTip(Button_8, "Copy Text To Clipboard")
  Button_10 = ButtonGadget(#PB_Any, 730, 230, 60, 25, "Copy")
  GadgetToolTip(Button_10, "Copy Text To Clipboard")
  Button_12 = ButtonGadget(#PB_Any, 730, 270, 60, 25, "Copy")
  GadgetToolTip(Button_12, "Copy Text To Clipboard")
  Button_14 = ButtonGadget(#PB_Any, 730, 310, 60, 25, "Copy")
  GadgetToolTip(Button_14, "Copy Text To Clipboard")
  
  ClearBtn = ButtonGadget(#PB_Any, 10, 370, 120, 25, "Clear All")
  GadgetToolTip(ClearBtn, "Clear All Fields Above")
  LoadDefaults_Btn = ButtonGadget(#PB_Any, 140, 370, 200, 25, "Load Defaults From File")
  GadgetToolTip(LoadDefaults_Btn, "Load Default Values From File .")
  SaveDefaults_Btn = ButtonGadget(#PB_Any, 350, 370, 190, 25, "Save Defaults To File")
  GadgetToolTip(SaveDefaults_Btn, "Save Default Values To File .")
  HelpBtn = ButtonGadget(#PB_Any, 550, 370, 120, 25, "Show Me How !")
  GadgetToolTip(HelpBtn, "Show Html-Color-Names-Totorial.html")
  ExitBtn = ButtonGadget(#PB_Any, 690, 370, 100, 25, "EXIT")
  GadgetToolTip(ExitBtn, "Close Program")
EndProcedure

Procedure ClearAll()
  CopyThis = 0
  Repeat
      CopyThis = CopyThis + 1
      If CopyThis = 1 : SetGadgetText(Editor_1, "") : EndIf 
      If CopyThis = 2 : SetGadgetText(Editor_2, "") : EndIf 
      If CopyThis = 3 : SetGadgetText(Editor_3, "") : EndIf 
      If CopyThis = 4 : SetGadgetText(Editor_4, "") : EndIf 
      If CopyThis = 5 : SetGadgetText(Editor_5, "") : EndIf 
      If CopyThis = 6 : SetGadgetText(Editor_6, "") : EndIf 
      If CopyThis = 7 : SetGadgetText(Editor_7, "") : EndIf 
      If CopyThis = 8 : SetGadgetText(Editor_8, "") : EndIf 
      If CopyThis = 9 : SetGadgetText(Editor_9, "") : EndIf 
      If CopyThis = 10 : SetGadgetText(Editor_10, "") : EndIf 
      If CopyThis = 11 : SetGadgetText(Editor_11, "") : EndIf 
      If CopyThis = 12 : SetGadgetText(Editor_12, "") : EndIf 
      If CopyThis = 13 : SetGadgetText(Editor_13, "") : EndIf 
      If CopyThis = 14 : SetGadgetText(Editor_14, "") : EndIf 
   Until CopyThis = 14

EndProcedure ; ClearAll()
  
Procedure LoadHtmlArray()
  CurrentHtmlArrayItem = 0
  CurrentHtmlArrayText$ = ""
  CopyThis = 1
  ClearList(HtmlArrayCode()) 
  If ReadFile(0, "DefaultValues.txt") 
    Repeat 
      CurrentHtmlArrayItem = AddElement(HtmlArrayCode()) 
      HtmlArrayCode() = ReadString(0) ; 
      If CopyThis = 1 : SetGadgetText(Editor_1, HtmlArrayCode()) : EndIf 
      If CopyThis = 2 : SetGadgetText(Editor_2, HtmlArrayCode()) : EndIf 
      If CopyThis = 3 : SetGadgetText(Editor_3, HtmlArrayCode()) : EndIf 
      If CopyThis = 4 : SetGadgetText(Editor_4, HtmlArrayCode()) : EndIf 
      If CopyThis = 5 : SetGadgetText(Editor_5, HtmlArrayCode()) : EndIf 
      If CopyThis = 6 : SetGadgetText(Editor_6, HtmlArrayCode()) : EndIf 
      If CopyThis = 7 : SetGadgetText(Editor_7, HtmlArrayCode()) : EndIf 
      If CopyThis = 8 : SetGadgetText(Editor_8, HtmlArrayCode()) : EndIf 
      If CopyThis = 9 : SetGadgetText(Editor_9, HtmlArrayCode()) : EndIf 
      If CopyThis = 10 : SetGadgetText(Editor_10, HtmlArrayCode()) : EndIf 
      If CopyThis = 11 : SetGadgetText(Editor_11, HtmlArrayCode()) : EndIf 
      If CopyThis = 12 : SetGadgetText(Editor_12, HtmlArrayCode()) : EndIf 
      If CopyThis = 13 : SetGadgetText(Editor_13, HtmlArrayCode()) : EndIf 
      If CopyThis = 14 : SetGadgetText(Editor_14, HtmlArrayCode()) : EndIf 
;        MessageRequester("Fruit: "+HtmlArrayCode(), "Now at position "+Str(ListIndex(HtmlArrayCode())),  #PB_MessageRequester_Ok)

      CopyThis = CopyThis + 1
  Until Eof(0) ; | TopicBtnCount > MaxBtnCount 
  CloseFile(0) 
  EndIf 
 EndProcedure ; LoadHtmlArray() 
 
Procedure SaveDefaults()
  CurrentHtmlArrayItem = 0
  CurrentHtmlArrayText$ = ""
  SaveThis = 0
;  ResetList(HtmlArrayCode()) ; HoldEditorStuff$
;  NextElement(HtmlArrayCode()) 
  If OpenFile(1, "DefaultValues.txt") ; If file can be created... 
    Repeat 
      SaveThis = SaveThis + 1
      If SaveThis = 1 : HoldEditorStuff$ = GetGadgetText(Editor_1) : EndIf 
      If SaveThis = 2 : HoldEditorStuff$ = GetGadgetText(Editor_2) : EndIf 
      If SaveThis = 3 : HoldEditorStuff$ = GetGadgetText(Editor_3) : EndIf 
      If SaveThis = 4 : HoldEditorStuff$ = GetGadgetText(Editor_4) : EndIf 
      If SaveThis = 5 : HoldEditorStuff$ = GetGadgetText(Editor_5) : EndIf 
      If SaveThis = 6 : HoldEditorStuff$ = GetGadgetText(Editor_6) : EndIf 
      If SaveThis = 7 : HoldEditorStuff$ = GetGadgetText(Editor_7) : EndIf 
      If SaveThis = 8 : HoldEditorStuff$ = GetGadgetText(Editor_8) : EndIf 
      If SaveThis = 9 : HoldEditorStuff$ = GetGadgetText(Editor_9) : EndIf 
      If SaveThis = 10 : HoldEditorStuff$ = GetGadgetText(Editor_10) : EndIf 
      If SaveThis = 11 : HoldEditorStuff$ = GetGadgetText(Editor_11) : EndIf 
      If SaveThis = 12 : HoldEditorStuff$ = GetGadgetText(Editor_12) : EndIf 
      If SaveThis = 13 : HoldEditorStuff$ = GetGadgetText(Editor_13) : EndIf 
      If SaveThis = 14 : HoldEditorStuff$ = GetGadgetText(Editor_14) : EndIf 
      WriteStringN(1,(HoldEditorStuff$)) 
        
    Until SaveThis = 14 
    CloseFile(1) 
  Else   
    MessageRequester("OpenFile(1,  ", "Can't Open File DefaultValues.txt")    
  EndIf 
EndProcedure ; SaveDefaults()
  
Procedure Btn01Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_1))
EndProcedure ; Btn01Paste()

Procedure Btn02Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_2))
EndProcedure ; Btn02Paste()
  
Procedure Btn03Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_3))
EndProcedure ; Btn03Paste()
  
Procedure Btn04Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_4))
EndProcedure ; Btn04Paste()

Procedure Btn05Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_5))
EndProcedure ; Btn05Paste()
  
Procedure Btn06Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_6))
EndProcedure ; Btn06Paste()
  
Procedure Btn07Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_7))
EndProcedure ; Btn07Paste()
  
Procedure Btn08Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_8))
EndProcedure ; Btn08Paste()
  
Procedure Btn09Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_9))
EndProcedure ; Btn09Paste()
  
Procedure Btn10Paste() ; Paste text to the clipboard..
  MessageRequester ("Procedure Btn10Paste()" , "Procedure Btn10Paste()")
  SetClipboardText(GetGadgetText(Editor_10))
EndProcedure ; Btn10Paste()
  
Procedure Btn11Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_11))
EndProcedure ; Btn11Paste()
  
Procedure Btn12Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_12))
EndProcedure ; Btn12Paste()
  
Procedure Btn13Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_13))
EndProcedure ; Btn13Paste()
  
Procedure Btn14Paste() ; Paste text to the clipboard..
  SetClipboardText(GetGadgetText(Editor_14))
EndProcedure ; Btn14Paste()

;================================================
OpenWindow_0()
CurrentPath$ = CurrentDIR$
Repeat
  Select WaitWindowEvent() 
    Case #PB_Event_Gadget 
      Select EventGadget() 
        Case LoadDefaults_Btn
             LoadHtmlArray()
        Case SaveDefaults_Btn
             SaveDefaults()
        Case ClearBtn
             ClearAll()
        Case HelpBtn
             RunProgram("http://vmars.us/freeware/HtmlCodeAssist/Html-Color-Names-Tutorial.html")
        Case Button_1  
             CopyThis = 1
             Btn01Paste()
        Case Button_2  
             CopyThis = 2
             Btn02Paste()
        Case Button_3  
             CopyThis = 3
             Btn03Paste()
        Case Button_4  
             CopyThis = 4
             Btn04Paste()
        Case Button_5  
             CopyThis = 5
             Btn05Paste()
        Case Button_6  
             CopyThis = 6
             Btn06Paste()
        Case Button_7  
             CopyThis = 7
             Btn07Paste()
        Case Button_8  
             CopyThis = 8
             Btn08Paste()
        Case Button_9  
             CopyThis = 9
             Btn09Paste()
        Case Button_10  
             CopyThis = 10
             Btn10Paste()
        Case Button_11  
             CopyThis = 11
             Btn11Paste()
        Case Button_12  
             CopyThis = 12
             Btn12Paste()
        Case Button_13  
             CopyThis = 13
             Btn13Paste()
        Case Button_14  
             CopyThis = 14
             Btn14Paste()
        Case ExitBtn  
          PostEvent(#PB_Event_CloseWindow)
      EndSelect 
    Case #PB_Event_CloseWindow : End 
  EndSelect 
ForEver 
; IDE Options = PureBasic 5.70 LTS (Windows - x86)
; CursorPosition = 289
; FirstLine = 285
; Folding = ----
; EnableXP
; EnableAdmin
; UseIcon = vmars-Logo.ico
; Executable = HtmlCodeAssist.exe
; DisableDebugger